Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 859)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 861)
@@ -4,14 +4,25 @@
 ! Current revisions:
 ! ------------------
+! ws-scheme also work with topography in combination with vector version.
+! ws-scheme also work with outflow boundaries in combination with
+! vector version.
+
+! Degradation of the applied order of scheme is now steered by multiplying with
+! Integer wall_flags_0. 2nd order scheme, WS3 and WS5 are calculated on each
+! grid point and mulitplied with the appropriate flag.
+! 2nd order numerical dissipation term changed. Now the appropriate 2nd order
+! term derived according to the 4th and 6th order terms is applied. It turns
+! out that diss_2nd does not provide sufficient dissipation near walls.
+! Therefore, the function diss_2nd is removed.
+
+! Near walls a divergence correction is necessary to overcome numerical
+! instabilities due to too less divergence reduction of the velocity field.
+!
+! boundary_flags and logicals steering the degradation are removed.
+! Empty SUBROUTINE local_diss removed.
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
-!
-! 856 2012-03-20 18:29:17Z suehring
-! Bug concerning numerical dissipation at the first grid level. Function
-! diss_2nd always returns zero.  Because diss_2nd will be replaced by numerical
-! dissipation which is more consistent to the WS-schemes, the return value
-! is set to zero for now.
 !
 ! 801 2012-01-10 17:30:36Z suehring
@@ -61,19 +72,15 @@
 ! routine using for initialisation and steering of the statical evaluation. 
 ! The computation of turbulent fluxes takes place inside the advection
-! routines. 
-! In case of vector architectures Dirichlet and Radiation boundary conditions
-! are outstanding and not available.
-! A further routine local_diss_ij is available (next weeks) and is used if a 
-! control of dissipative fluxes is desired.
-!
-! OUTSTANDING: - Dirichlet and Radiation boundary conditions for 
-!                vector architectures
-!              - dissipation control for cache architectures ( next weeks )
-!              - Topography ( next weeks )
+! routines.
+! Near non-cyclic boundaries the order of the applied advection scheme is
+! degraded.
+! A divergence correction is applied. It is necessary for topography, since
+! the divergence is not sufficiently reduced, resulting in erroneous fluxes and
+! partly numerical instabilities. 
 !-----------------------------------------------------------------------------!
 
     PRIVATE
     PUBLIC   advec_s_ws, advec_u_ws, advec_v_ws, advec_w_ws, &
-             local_diss, ws_init, ws_statistics
+             ws_init, ws_statistics
 
     INTERFACE ws_init
@@ -104,9 +111,4 @@
        MODULE PROCEDURE advec_w_ws_ij
     END INTERFACE advec_w_ws
-
-    INTERFACE local_diss
-       MODULE PROCEDURE local_diss
-       MODULE PROCEDURE local_diss_ij
-    END INTERFACE local_diss
 
  CONTAINS
@@ -126,21 +128,11 @@
 
 !
-!--    Allocate arrays needed for dissipation control.
-       IF ( dissipation_control )  THEN
-!          ALLOCATE(var_x(nzb+1:nzt,nys:nyn,nxl:nxr),        &
-!                   var_y(nzb+1:nzt,nys:nyn,nxl:nxr),        &
-!                   var_z(nzb+1:nzt,nys:nyn,nxl:nxr),        &
-!                   gamma_x(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-!                   gamma_y(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-!                   gamma_z(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
-       ENDIF
-
-!
 !--    Set the appropriate factors for scalar and momentum advection.
        adv_sca_5 = 1./60.
        adv_sca_3 = 1./12.
+       adv_sca_1 = 1./2.
        adv_mom_5 = 1./120.
        adv_mom_3 = 1./24.
-
+       adv_mom_1 = 1./4.
 !         
 !--    Arrays needed for statical evaluation of fluxes.
@@ -231,29 +223,4 @@
        ENDIF
 
-!
-!--    Determine the flags where the order of the scheme for horizontal 
-!--    advection has to be degraded.
-       ALLOCATE( boundary_flags(nys:nyn,nxl:nxr) )
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-
-             boundary_flags(j,i) = 0
-             IF ( outflow_l )  THEN
-                IF ( i == nxlu  )  boundary_flags(j,i) = 5
-                IF ( i == nxl   )  boundary_flags(j,i) = 6
-             ELSEIF ( outflow_r )  THEN
-                IF ( i == nxr-1 )  boundary_flags(j,i) = 1
-                IF ( i == nxr   )  boundary_flags(j,i) = 2
-             ELSEIF ( outflow_n )  THEN
-                IF ( j == nyn-1 )  boundary_flags(j,i) = 3
-                IF ( j == nyn   )  boundary_flags(j,i) = 4
-             ELSEIF ( outflow_s )  THEN
-                IF ( j == nysv  )  boundary_flags(j,i) = 7
-                IF ( j == nys   )  boundary_flags(j,i) = 8
-             ENDIF
-
-          ENDDO
-       ENDDO
-       
     END SUBROUTINE ws_init
 
@@ -271,5 +238,5 @@
 !       
 !--    The arrays needed for statistical evaluation are set to to 0 at the 
-!--    begin of prognostic_equations.
+!--    beginning of prognostic_equations.
        IF ( ws_scheme_mom )  THEN
           sums_wsus_ws_l = 0.0
@@ -307,7 +274,6 @@
        IMPLICIT NONE
 
-       INTEGER ::  i, i_omp, j, k, tn
-       LOGICAL ::  degraded_l, degraded_s
-       REAL    ::  flux_d, diss_d, u_comp, v_comp
+       INTEGER ::  i, i_omp, j, k, tn, k_ppp, k_pp, k_mm
+       REAL    ::  flux_d, diss_d, u_comp, v_comp, div
        REAL, DIMENSION(:,:,:), POINTER    :: sk
        REAL, DIMENSION(nzb:nzt+1)         :: flux_t, diss_t, flux_r, diss_r,  &
